<script lang="ts">
import Vue from 'vue';

import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../../../common/meta';
import {
  NextStepAlt,
  PricingBanner,
  QuoteCarousel,
} from '~/components/common/index.vue';
import { RoiCalculatorBlock } from '~/components/pricing/plans/index.vue';
import {
  WhyUpgradeCardGroup,
  WhyUpgradeHero,
  WhyUpgradeLogos,
  WhyUpgradeQuote,
  WhyUpgradeStats,
  WhyUpgradeTable,
} from '~/components/why-upgrade/index.vue';
export default Vue.extend({
  components: {
    WhyUpgradeHero,
    WhyUpgradeStats,
    WhyUpgradeLogos,
    WhyUpgradeQuote,
    WhyUpgradeCardGroup,
    WhyUpgradeTable,
    RoiCalculatorBlock,
    QuoteCarousel,
    NextStepAlt,
    PricingBanner,
  },
  async asyncData({ $whyUpgradeService }: any) {
    try {
      const content = await $whyUpgradeService.getContent(
        'pricing/premium/why-upgrade',
      );
      return {
        content,
      };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).content,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="why-upgrade">
    <PricingBanner v-bind="content.banner" />
    <SlpContainer class="why-upgrade-navigation">
      <SlpSideNavigation
        v-if="content.ctfSideNavigation.data"
        :data="content.ctfSideNavigation.data"
      >
        <template v-if="content.ctfSideNavigation.data.hyperlinks.data" #header>
          <div class="pricing-plan__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in content.ctfSideNavigation.data
                .hyperlinks.data"
              :key="buttonIndex"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              class="slp-mb-32"
              >{{ button.text }}
              <SlpIcon
                v-if="button.icon"
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
        </template>
        <WhyUpgradeHero v-if="content.hero" v-bind="content.hero" />
        <WhyUpgradeStats
          v-if="content.ctfCardGroupStats"
          v-bind="content.ctfCardGroupStats"
        />
        <WhyUpgradeLogos
          v-if="content.ctfCustomerLogos"
          v-bind="content.ctfCustomerLogos"
        />
        <WhyUpgradeQuote v-if="content.ctfQuote" v-bind="content.ctfQuote" />
        <WhyUpgradeCardGroup
          v-if="content.ctfCardGroup"
          v-bind="content.ctfCardGroup"
        />

        <section
          v-if="content.ctfQuotesCarousel"
          id="customer-success"
          class="why-updgrade-quote-carousel"
        >
          <QuoteCarousel v-bind="content.ctfQuotesCarousel" />
        </section>

        <section
          v-if="content.ctfRoiCalculator"
          id="roi-calculator"
          class="why-updgrade-roi-calculator"
        >
          <RoiCalculatorBlock :data="content.ctfRoiCalculator.data" />
        </section>
        <WhyUpgradeTable
          v-if="content.headerAndText"
          v-bind="content.headerAndText"
        />
      </SlpSideNavigation>
    </SlpContainer>
    <NextStepAlt id="get-started" variant="why-upgrade" />
  </div>
</template>

<style scoped lang="scss">
.why-upgrade {
  [id]::before {
    content: '';
    display: block;
    height: 75px;
    margin-top: -75px;
    visibility: hidden;
  }
  &__section {
    border-bottom: 1px solid $color-surface-300;
    padding-bottom: 48px;
    margin-bottom: 48px;
    &:first-of-type {
      margin-top: 32px;
      @media (min-width: $breakpoint-md) {
        margin-top: 0;
      }
    }
  }
}
.why-upgrade-navigation {
  padding-top: 64px;
  @media (min-width: $breakpoint-lg) {
    padding-top: 96px;
  }
}

.gradient-line {
  height: 4px;
  width: 96px;
  border-radius: 20px;
  background: rgb(255, 203, 215);
  background: linear-gradient(
    90deg,
    rgba(255, 203, 215, 1) 0%,
    rgba(241, 205, 234, 1) 51%,
    rgba(211, 191, 238, 1) 100%
  );
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.why-updgrade-quote-carousel {
  &:deep {
    .slp-text-heading2-bold,
    .slp-text-heading2-bold * {
      margin-top: 48px;
      display: block;
      @media (min-width: $breakpoint-md) {
        font-size: 40px;
        margin-top: 80px;
        line-height: 42px;
      }
    }
    .quote-carousel-wrapper {
      min-height: 100%;
      @media (min-width: $breakpoint-md) {
        gap: 16px;
      }
    }
  }
}
.why-updgrade-roi-calculator {
  &:deep {
    .slp-text-heading3-bold {
      @media (min-width: $breakpoint-md) {
        font-size: 32px;
        font-weight: 400;
        line-height: 40px;
        letter-spacing: -0.02em;
        text-align: left;
      }
    }
    .container {
      border-radius: 4px;
      padding: 20px;
      @media (min-width: $breakpoint-md) {
        padding: 40px;
      }
    }
    .gradient-line-block {
      margin: 24px 0 0 0;
      @media (min-width: $breakpoint-md) {
        margin: 72px 0 0 0;
      }
    }
    .gradient-line {
      margin-top: 0;
    }
  }
}
</style>
